#include "../fusCompileConfig.hpp"

#ifdef FUS_IRRLICHT_SUPPORT

#ifndef _FUSION_IRRLICHT_OPERATORS_HPP_INCLUDED
#define _FUSION_IRRLICHT_OPERATORS_HPP_INCLUDED

//#include "../logging/Logger.hpp>
#include "../logging/Logger.hpp"
#include <irrlicht.h>
#include <irrList.h>

//
//template <const irr::scene::ISceneNode*>
//fus::Logger&
//operator <<(fus::Logger& logger,const irr::scene::ISceneNode* scene)
//{
//    if(scene == 0){
//        logger.Log(fus::ELogLevel::Append) << " Scene node == 0 ";
//        return logger;
//    }
//
//
//    logger.Log(fus::ELogLevel::Append) << " Scene node: " << scene->getName();
//    irr::core::list<irr::scene::ISceneNode*>::ConstIterator it = scene->getChildren().begin();
//    for(; it != scene->getChildren().end();it++ )
//    {
//        logger << *it;
//    }
//
//    return logger;
//}


template <class T>
fus::Logger&
operator <<(fus::Logger& logger,const irr::core::vector3d<T>& v){

    logger.Log(fus::ELogLevel::Append) << "Irrlicht Vector: " << v.X << "/" << v.Y << "/" << v.Z;
    return logger;
}


template <class T,class U>
fus::Logger&
operator <<(fus::Logger& logger,const std::pair < T, U >& p ){

    logger.Log(fus::ELogLevel::Append) << "std::pair [" << p.first << "/" << p.second << "]";
    return logger;
}





template <class T>
fus::Logger&
operator <<(fus::Logger& logger,const irr::core::rect<T>& rect){

    logger.Log(fus::ELogLevel::Append) << "Irrlicht Rect: X/Y: " << rect.UpperLeftCorner.X << "/" << rect.UpperLeftCorner.Y
                        << " Width/Height" << rect.getWidth() << "/" << rect.getHeight();
    return logger;
}

#endif


#endif
