#include "IFleet.hpp"
#include "game_engine.hpp"
#include "states/IPlayableState.hpp"
#include "entities/player.hpp"
//#include "CGraphicalLevel.hpp"
//#include "states/CSinglePlayerState.hpp"
#include <fusion/logging/Logger.hpp>
#include <fusion/maths/macros.hpp>
#include <iostream>
#include "fx/CParticleManager.hpp"
#include "entities/CBullet.hpp"
#include "entities/CStaticBattery.hpp"
#include "entities/CMissile.hpp"
#include "audio/ISound.hpp"
#include <boost/foreach.hpp>

using namespace irr;


IFleet::TDeadPool IFleet::_deadPool;



//CSinglePlayerState* state
//IFleet::IFleet(audio::ISoundManager* soundMgr) :
IFleet::IFleet(IPlayableState* state) :
//    _soundMgr(soundMgr)
    _state(state)
{
    //ctor
    FUS_ASSERT( _state );
}



IFleet::~IFleet()
{
    //dtor
    if(_fleetRootNode){
        _fleetRootNode->remove();
    }
}

//CBullet*
////IStaticBattery*
//IStaticBattery::shootBullet(const char* model,const float& deviation)
//{
//
//
//    CBullet* bullet = getFleet()->createAndSetupBullet(model, this->getRotation().Y + deviation);
//    bullet->setPosition( this->getPosition() );
//    //bullet->
//    return bullet;
//}



// get nearest missile
IStaticBattery*
IFleet::getNearestEnemy(const TVector3df& position)
{


    auto nextBattery(_activeBatteries.begin()), last( _activeBatteries.end() );
    IStaticBattery* current = 0;

    //_INFO << "START \r\n";
    while( nextBattery != last )
    {

        nextBattery++;
//        current = nextBattery;
//        nextBattery = current->_next;

    }
//    while(j != j_end){
//
//        if(j->getPosition().getDistanceFromSQ( position) < nearestMissile->getPosition().getDistanceFromSQ( position)){
//            nearestMissile = j;
//        }
//        ++j;
//    }
//    return &(*nearestMissile);
    return 0;
}



IStaticBattery*
IFleet::getNextTarget(const std::list<IStaticBattery*>& trackedBatteries)
{


    //auto

    /*CStaticBattery *nextBattery = _activeBatteries.front();
    //CStaticBattery* current = 0;

    //_INFO << "START \r\n";
    while(nextBattery){

        TTrackedBatteries::const_iterator it = std::find( trackedBatteries.begin(), trackedBatteries.end(), nextBattery );

        // if battery not already tracked
        if(it == trackedBatteries.end() ){

            return nextBattery;
        }


        nextBattery = nextBattery->_next;

    }*/

    return 0;
}

//void
//IFleet::killEntity(CStaticBattery* ){
//
//}
//




IStaticBattery*
IFleet::getDeadButAllocatedBattery(const EEntityType::EId& type)
{

    IStaticBattery* battery = 0;
  //  #error not existing
    if( !_deadPool[type].empty() )
    {

        battery = _deadPool[type].front();
        _deadPool[type].pop_front();
    }
    else
    {

        FUS_ASSERT( _state != 0 && "IFleet should have a playable state to refer to");
        // HACK while game is singleton
        scene::IAnimatedMeshSceneNode*    node = _state->addAnimatedNode();

//        node = smgr->addAnimatedMeshSceneNode( 0,  // fleet
//                                            0,   // parent
//                                            -1, //id
//                                            core::vector3df(0, 0, 0),   //position
//                                            core::vector3df(0, 0, 0), //rotation
//                                            core::vector3df(1.0f, 1.0f, 1.0f), // scale
//                                            true        // add node even without mesh
//                                            );


//        _INFO << "creating from scratch";
        switch(type)
        {

            case EEntityType::Bullet:
                battery = new CBullet();
                break;

            case EEntityType::Battery:
                battery = new CStaticBattery();
                break;

            case EEntityType::Missile:
                battery = new CMissile();
                break;

            default:
                break;
        }


        //
        battery->_node = node;

    }

    FUS_ASSERT( battery != 0);



    return battery;
}


void
IFleet::addConfiguredEntityToAliveBatteries(IStaticBattery* battery)
{

//    battery->_next = _root;
//    _root = battery;

    //_aliveBatteries.push_front( battery );
    battery->setFleet(this);
    battery->_damageInflictedOnCollision = 0;
    _activeBatteries.push_front( battery );
}




void
IFleet::killAllAlive()
{

    // TODO les mettre tous en deadPool
}



void
IFleet::destroyAll()
{

//static void ();
    clearDeadPool();
    //std::for_each()
}



void
IFleet::clearDeadPool()
{

//    for( : )
    BOOST_FOREACH(auto& pool, _deadPool){

        pool.clear();
    }

    //std::for_each()
}



irr::scene::IAnimatedMesh*
IFleet::getMesh(
                        const char* filename
                        )
{

    FUS_ASSERT( _state );
    return _state->getMesh(filename);
}

CMissile*
IFleet::createAndSetupMissile(const char* model,const TVector3df& forward,const TVector3df& position )
{

    IStaticBattery* battery = getDeadButAllocatedBattery(EEntityType::Missile);
    CMissile* missile = dynamic_cast<CMissile*>(battery);

    missile->setup(
                   model,
                   this,
                   position,
                   forward
                   );

    addConfiguredEntityToAliveBatteries(missile);

    return missile;
}


//,CStaticBattery* creator
//const char* model
CStaticBattery*
IFleet::createAndConfigureStaticBattery()
{

    IStaticBattery* battery = getDeadButAllocatedBattery(EEntityType::Battery);


    //addBattery(batt);
    addConfiguredEntityToAliveBatteries(battery);


    //_INFO << "auto updated battery created with range" << battery->getParameter(NParameters::Range);
    return dynamic_cast<CStaticBattery*>( battery );
}





CBullet*
IFleet::createAndSetupBullet(const char* model,
                  const float& angleDeg
                  //,
                  //const TVector3df& position
                )
{
//, position
    TVector3df forward(0,0,-0.01);
    getVectorFromAngle(angleDeg,forward);
    return createAndSetupBullet(model, forward);
}






//,const TVector3df& position
CBullet*
IFleet::createAndSetupBullet(const char* model,const TVector3df& forwardVec )
{

    IStaticBattery* battery = getDeadButAllocatedBattery(EEntityType::Bullet);

    FUS_ASSERT(battery != nullptr);

    CBullet* bullet = dynamic_cast<CBullet*>(battery);


// setup
//TODO remplacer par un init la ?
    bullet->setFleet(this);
    bullet->setMesh( this->getMesh(model) );

    bullet->_forward = forwardVec;



//    if(!bullet->setup(model,this,position,forward)){
//        _LOG_WARNING << "Could not configure bullet";
//
//        // TODO on devrait le remettre dans le pool
//        delete bullet;
//
//        return 0;
//    }

    // TODO HACK
    //bullet->_parameters

    addConfiguredEntityToAliveBatteries(bullet);

    return bullet;
}





void
IFleet::draw()
{
//    if(_fleetRootNode->isVisible()){
//        _INFO << "fleet nodes set invisible";
//        //_fleetRootNode->setVisible(false);
//    }

//draw2DPolygon (core::position2d< s32 > center, f32 radius, video::SColor color=SColor(100, 255, 255, 255), s32 vertexCount=10)=0
//
//    core::list<ISceneNode*>  const& children = _fleetRootNode->getChildren();
//    irr::scene::ISceneCollisionManager* temp =  _level->_state->scene()->getSceneCollisionManager();
//    core::position2di pos2d;
//
//    //TBulletPool::TElementIterator i(_bullets.begin()),i_end(_bullets.end());
//    //TBulletPool::TElementIterator i(_bullets.begin()),i_end(_bullets.end());
//    core::list<ISceneNode*>::ConstIterator i( children.begin() ),i_end( children.end() );
//    while(i != i_end){
//
//        _level->_state->engine().driver->setTransform(video::ETS_WORLD,core::IdentityMatrix);
//
//        const core::vector3df& pos3d = (*i)->getAbsolutePosition();
//        //const core::vector3df& rpos3d = (*i)->getPosition();
//        pos2d = temp->getScreenCoordinatesFrom3DPosition ( pos3d );
//        //getCenter()
//        //i->getRange()
//        _level->_state->engine().driver->draw2DPolygon(pos2d , 10);
//        _INFO << "hitbox displayed. Range .... at pos" << pos2d.X << "/" << pos2d.Y;// << i->getRange();
//        _INFO << "Pos 3D: " << pos3d.X << "/" << pos3d.Y<< "/" << pos3d.Z;// << i->getRange();
//        //_INFO << "Relative Pos 3D: " << rpos3d.X << "/" << rpos3d.Y<< "/" << rpos3d.Z;// << i->getRange();
//        ++i;
//    }

//    TMissilePool::TElementIterator j(_missiles.begin()),j_end(_missiles.end());
//    while(j != j_end){
//
//        ++j;
//    }
}












// apparemment le bug vient pas de cette fct
//,CSinglePlayerState* state
void
IFleet::update(const TTimer::TimeType& time)
{
    //BOOST_ASSERT(state);
/*
    //BOOST_FOR
//    CStaticBattery* nextBattery = front();
//    CStaticBattery* current = 0;

    //CBattery* battery = _activ
    //_INFO << "START \r\n";
    while(nextBattery){


        current = nextBattery;
        nextBattery = current->_next;

        // check conditions of death
        //getDamage ?
        if( current->getRemainingLife() < 0 ){

//          engine().addExplosion();
//          engine().addSound();
            current->onDeath();

            killEntity( current );

            _fightingState->addSimpleExplosion( current->getPosition() );
            //CGameEngine::getAudioManager()->Play("sounds/explosion.wav");
//            CSound* sound = new CSound("sounds/explosion.wav");
//            sound->play();
            //state->shakeCamera();

            _INFO << "onDeath : battery damage > 0 => EXPLOSION";
        }
        //battery->timerExpired()
        //_timer.reached
        else if( current->outOfScreenTimeout() ){
         //return true;
            current->onTimeoutDisparition();
            //_INFO << "time out death";
            killEntity( current );

        }
        else {
            //_INFO << "Update \r\n";
            current->update(time);
        }
    }
    */


    //bool erasePreviousBattery = false;

    // runs from the end to the beginning



    auto beginBattery( _activeBatteries.begin() );
    auto beforebeginBattery( _activeBatteries.before_begin());
    auto lastBattery( _activeBatteries.end() );



    //auto previousBattery = lastBattery;
    //auto currentBattery = lastBattery;
    auto it = lastBattery;
    //auto battery
    //for ( auto battery( _activeBatteries.begin() ), ; battery != firstBattery; --battery){

    // Pas de -- sur les iterators de cette classe
    for( ;it != lastBattery; ++it )
    {

        auto battery = *it;
        battery->update(time);

        // We should check out of screen at some interval,
        // not every frame todo
#if 0
        // check conditions of death
        if( battery->getRemainingLife() < 0 )
        {

            battery->onDeath();
//            erasePreviousBattery = true;
            //killEntityNextTo( previousBattery );

            //CGameEngine::getAudioManager()->Play("sounds/explosion.wav");
//            CSound* sound = new CSound("sounds/explosion.wav");
//            sound->play();
            //state->shakeCamera();

            _INFO << "onDeath : battery damage > 0 => EXPLOSION";
        }
        //battery->timerExpired()
        //_timer.reached
        else
        #endif

        if( battery->outOfScreenTimeout() )
        {

            battery->onTimeoutDisparition();
            //_INFO << "time out death";
//            erasePreviousBattery = true;

        }
        else
        {
            //_INFO << "Update \r\n";
            battery->update(time);
        }



    }


    //_INFO << "END \r\n";
}



void
//IFleet::killEntityNextTo(CStaticBattery* battery) {
IFleet::killBattery(TBatteryContainer::iterator& it)
//IFleet::killBattery(IStaticBattery* battery)
{

    //BOOST_ASSERT(battery != 0);

//    CStaticBattery* previous = battery->_previous;
    IStaticBattery* battery = *it;

    const EEntityType::EId type = battery->getType();

    if(type == EEntityType::Player )
    {

        dynamic_cast<CPlayer*>(battery)->kill();
        _INFO << "killing player";
    }
    else
    {


        _activeBatteries.erase_after(it);
        _deadPool[ type ].push_front(battery);

        // If static battery then
        if( type == EEntityType::Battery)
        {
            // call lua function

            //lua_State* L = ;
            try
            {

                _INFO << "Killing static battery [" << battery << "]";
                //luabind::call_function<void>( _fightingState->_script->getVM(), "killBattery", battery);
            }
            catch(std::exception& e)
            {
                //appellà manager:Killtask()
                //_LOG_ERROR << "call_function from C++ launched an exception" << e.what();
                std::string errorMsg;
                //if(!_fightingState->_script->retrieveStringFromStack(errorMsg)){
//                    errorMsg = "No string on top of stack";
//                }

               // _fightingState->engine().popupMessage(L"call_function => error " , errorMsg );
            }
        }
    }



}




// TODO  passer un shared_ptr ? ne rien renvoyer
bool
IFleet::checkCollisions(IFleet* fleet)
{

    FUS_ASSERT(fleet != 0);



    auto ally = _activeBatteries.begin();
    auto lastAlly  = _activeBatteries.end();

    // foreach unit from this fleet
    for( ;ally != lastAlly ; ++ally)
    {

        auto enemy = fleet->_activeBatteries.begin();
        auto lastEnemy = fleet->_activeBatteries.end();

        // foreach unit from adverse fleet
        for(;enemy != lastEnemy; ++ enemy)
        {

            // if both collide
            if( (*enemy)->checkCollision(*ally) )
//            if( checkCollision( *ally, *enemy) )
            {

                // TODO renommer en ...With
                //_INFO << "collision >> enemy damage before collision [" << enemy->getDamage() << "]";
                onCollision(*ally, *enemy);

//                (*enemy)->onCollision( *ally );
//                (*ally)->onCollision( *enemy );

                //_INFO << "enemy damage after collision [" << enemy->getDamage() << "]";
                return true;
            }

            //enemy = enemy->_next;
        }
        //ally = ally->_next;
    }

/*
    CStaticBattery* ally = front();
    // foreach unit from this fleet
    while(ally){

        CStaticBattery* enemy = fleet.front();

        // foreach unit from adverse fleet
        while(enemy){

            // if both collide
            if( enemy->checkCollision(ally) ){

                // TODO renommer en ...With
                //_INFO << "collision >> enemy damage before collision [" << enemy->getDamage() << "]";

                enemy->onCollision( ally );
                ally->onCollision( enemy );

                //_INFO << "enemy damage after collision [" << enemy->getDamage() << "]";
                return true;
            }

            enemy = enemy->_next;
        }
        ally = ally->_next;
    }
*/
    return false;
}

