/**
* \file player.hpp
* \todo regourper tous les input pour les passer en parametre ? dans les update
*/
#ifndef ENTITY_PLAYER_HPP
#define ENTITY_PLAYER_HPP


//#include "IEntity.hpp"
//#include "IMultiModeTransformer.hpp"
#include "SModeDescription.hpp"
#include "CStaticBattery.hpp"
#include <fusion/macros.hpp>
//#include "../IEngineConfig.hpp"
#include <irrlicht.h>
#include <bitset>
#include <list>
//#include <slist>
#include <array>
#include <luabind/luabind.hpp>
//#include <boost/circular_buffer_fwd.hpp>
#include <boost/circular_buffer.hpp>
#include <boost/weak_ptr.hpp>
#include "../def.hpp"
#include "../events/SCachedState.hpp"
#include "../events/CBindCollectionPlayer.hpp"
#include <irrlicht.h>

//forward declaration
class CPlayer;
class  IWalkyrie;




//class CBindCollection;


namespace SPK {
    namespace IRR {
        class IRRSystem;
    }
}

namespace NWalkyrieModel
{
enum EId
{
YF19,
YF21
};
}

//namespace NBooster {
//enum EId {
//Left,
//Right,
//Count
//};
//}


typedef std::size_t TPlayerId;

//! Register performances of the player
struct SStats
{
SStats();

int Destroyed;  //!< Number of destroyed enemies
//int Level;      //!< Reached level
int Score;      //!< Score
int Deaths;     //!< number of deaths registered
int NbOfTransformations;
void addKill(CStaticBattery*);
//addDeath()
//std::array<int,CPlayer::ModesCount> PlayedTimes;
};






//forward declaration
class CGameEngine;
class CBindDescriptor;
class CSinglePlayerState;
class IWalkyrieMode;
class IPlayerAnimator;


//typedef IMultiModeTransformer TWalkyrie;


//typedef std::array<>

//typedef (CPlayer::*TMoveFunction)(const irr::u32& elapsedTime) (CPlayer::*TMoveFunction)(const irr::u32& elapsedTime);






////////////////////////////////////////////////////////
////    Function used to move player
////////////////////////////////////////////////////////
/** \brief
 *
 * \param
 * \param
 * \return
 *
 */


//                                            _cachedInput[ NPlayerInput::MoveForward], \
//                                            _cachedInput[ NPlayerInput::MoveBackward]

//typedef bool (*TPlayerMoveFunction)(
//                    DECLARE_PLAYER_MOVEFUNC_PARAMS
//                    );
//typedef bool (CPlayer::*TPlayerMoveFunction)(CPlayer& player, const irr::u32& elapsedTime,const SBindCache& moveLeft, const SBindCache& moveRight, const SBindCache& moveForward, const SBindCache& moveBackward);





// Derive de CStaticBattery pr pvr etre pris en chasse par
class CPlayer :
//public IMultiModeTransformer,
    public IStaticBattery
{
    // TODO to remove
//    static const NWalkyrieModes::ERealMode _virtualModes[2][3];


protected:
    int LivesLeft;

private:
    enum EElapsedTime {
    SinceLastMissile,
    SinceLastShot,
    SinceLastTransformation,
    //SinceBeingKilled,
    SinceLastBlinkRevival,
    //Cooldown,
    ElapsedTimesCount
    };


    //typedef std::list<CStaticBattery*> TTrackedBatteries;
    CMissile* _trackedMissile;

    // Mettre des timers ?
    typedef std::array<TTimer::TimeType,ElapsedTimesCount> TElapsedTimes;
    TElapsedTimes _elapsedTimes;

//    CGameEngine& _engine;
//    CSinglePlayerState* _fightingState;


    //!
    irr::f32 _missilesHeat;


    //!
    irr::f32 _cannonHeat;
    TTimer::TimeType _elapsedTimeSinceLastOverheat;
    bool _coolingDown;


    //////////////////////////////////////////////
    /// Set to true as soon as touch pressed, when key released, then throw missiles
    //////////////////////////////////////////////
    bool _targeting;




protected:
    void startCoolingDown();
    void stopCoolingDown();

    const bool isTrackingEnemies() const { return _targeting; };

//    bool BasicUpdatePositionFunction(const TTimer::TimeType& elapsedTime);


    //! TODO mettre ailleurs ?
//    CBindCollection *_mappingSet;
    IWalkyrie* _walkyrie;

public:
//    TVector3df _rotation;
//    TVector3df _targetedRotation;
//    TVector3df _previousRotation; // sert de backup ds le cas d'1 tracking misisile
//    TVector3df _currentPos;

    CPlayer();
    ~CPlayer();


    int getNumberOfLivesLeft() const { return LivesLeft; };

    float getCannonHeatRatio() const;


    bool setWalkyrie(IWalkyrie* walkyrie);
//    std::map<NPlayerInput::TBindId, SBindCache> _cachedInput;
//    std::map<NPlayerInput::EId, SBindCache> _cachedInput;

    TTrackedBatteries _trackedBatteries;

    //!
//    std::bitset< static_cast<int>(NPlayerInput::Count) > CachedInput;
//    NWalkyrieModel::EId _walkyrieType;
    // Les passer en std


    /** \brief
     *
     * \param
     * \param
     * \return
     *
     */
    //bool setup(IWalkyrie* walkyrie, const CBindCollection* mappingSet);


    // todo creer une lanceur de missiles ?
    // voir comment on stock les missiles ?
    int _missilesLeft;

    // on ne s'en sert pas pr l'instant
//    std::string _name;  // nom du vaisseau "yf19 ou yf21 par exemple
    IWalkyrie* getWalkyrie() const { return _walkyrie;};

    void onTimeoutDisparition();
    void onDeath();
//    void onCollision(IStaticBattery*);
    // TODO should set a ITransformerMode
//    void setupAsModel( const NWalkyrieModel::EId& id );

    const EEntityType::EId getType() const { return EEntityType::Player;};



    float getRange() const;

    void setupNewLife();

    // TODO faire sans
    //void getMappingDescription(lua_State* L,const int& id);

    // void attachWeapon
    // IWeapon
    const bool& coolingDown() const;

    void kill();

    bool update(const TTimer::TimeType& elapsed, CBindCollectionPlayer::TCache& cache);

    // TODO va dans walkyrie
    float getCruiseSpeed();// const;

    void setAnimator(IPlayerAnimator* );

    bool processTransformations(const SBindCache& modeUp, const SBindCache& modeDown );


    // TODO
    bool startTrackingEnemies();
    bool stopTrackingEnemies();
    bool trackNewBattery();

//    CGameEngine& engine() const;

    irr::scene::ISceneNode *getNode();

    /**
    void clearModes(const NWalkyrieModes::EVirtualMode&);
    // TODO renommer en addMode
    void allowMode(const NWalkyrieModes::EVirtualMode& mode);
    **/

//    TPlayerMoveFunction
    IPlayerAnimator *UpdatePositionFunction;
//    TShootFunction UpdateShootingsFunction;

};

#endif
