/**
* \file single.h
**/
#ifndef IPlayableState_HPP
#define IPlayableState_HPP

#include "../states/IGameState.hpp"
#include "../entities/player.hpp"
#include <map>
#include <boost/weak_ptr.hpp>
//#include <mirrpp/CScreenQuadCB.hpp>

#include <list>
#include <irrlicht.h>
#include <memory>
#include "../utils/IClock.hpp"





void enableMenu(irr::gui::IGUITab* , const bool&);

// Forward declaration


//namespace NTexture {
//enum EId {
//Life = 0,
//Energy,
//Explosion,
//Cursor,
//Lockon,
//Count  // Doit toujours rester dernier
//};
//}


//namespace NCamera {
//enum EId {
//LeftHUD,
//RightHUD,
//Scene,
//Flying,
//Count
//};
//
//}

namespace NPlayState
{
    enum EId
    {
    Dialog,
    InitializingScriptingEngine,
    Editing,
    Playing,
    //Revival,
    //PlayerDead,
    NoLevelLoaded,
    Uninitialized,
    Cinematic,
    Menu,
    BossWarning,
    EndingLevel,
    StartingLevel,
    GameOver,
    Count
    };

}


//! fwd
//class ILevel;
class CBindCollectionPlayer;
class CScreenQuadWithShader;
class CLifebarCB;
class CAlliedFleet;
class CEnemyFleet;

/**
TODO pvr gerer les transitions

**/
DECLARE_GAME_STATE( IPlayableState )
//class IPlayableState : public IBasicGameState
{

private:
//    boost::shared_ptr<CFadingImage> _levelTransitionImage;
//    bool isLoaded() const;
protected:

    enum class  Phase
    {
        FadeIn,
        Setup,
        Playing,
        Boss,
        FadeOut,
//        IngameMenu,
        Undefined
    };
    Phase CurrentPhase;

    CAlliedFleet* _alliedFleet;
    CEnemyFleet* _enemyFleet;

//    typedef std::pair<CPlayer,SPlayerContext> TPlayerPair;
    typedef CPlayer TPlayerPair;
    std::vector< TPlayerPair > Players;//vont etre geree via entitymanager
    //ICameraSceneNode* _camera;

    CPlayer Player;

//    inline TPlayerPair& getPlayer(const std::size_t& id = 0) { return Players[id]; };
    inline TPlayerPair& getPlayer(const std::size_t& id = 0)  { return Player; };


//    CBindCollectionPlayer* _playerMapping;
//    std::map<NPlayerInput::EId, SBindCache> _cachedInput;   // For player 1

//    void updateInput();

    //! tout ca va dans IPlayable
//    bool startTrackingEnemies();
//    bool stopTrackingEnemies();
//    bool trackNewBattery();


    irr::video::ITexture* _rttHud;
    irr::video::ITexture* _rttScene;

    // HUD textures
    irr::video::ITexture* _lifebar;
    irr::video::ITexture* _lifePictogram;
    irr::video::ITexture* _heatbar;
    irr::video::ITexture* _cannonPictogram;

    //! Fade Shader callback
    irr::s32 _lifebarMat;

	bool handleMainEvents(const irr::SEvent&);

    CScreenQuadWithShader* _customQuad;
    CLifebarCB* _lifebarCB;




public:

    // HACK
    irr::scene::ISceneNode *_cachedFleetNode;
    irr::scene::ISceneNode *_activeFleetNode;


    /** \brief
     *
     * \param State name
     */

    IPlayableState(const std::string& name);

    // TODO la je passe forcement le nom du niveau a charger
    ~IPlayableState();

    /** \brief Should be overriden by derivatives
     *
     * \param
     * \param
     * \return
     *
     */

    virtual bool load( CGameEngine*,irr::scene::ISceneManager*,irr::video::ITexture* );
//    virtual void unload() = 0;


    irr::core::dimension2du getSceneDimensions() const;

//    virtual void onUpdate(const TTimeUnit& elapsedTime) = 0;
    virtual void clampPositionToAccessibleArea(irr::core::vector3df& pos) ;


    virtual bool isEntityOufOfScreen(const IStaticBattery* battery) const ;

//    virtual void onBatteryTimeoutDisparition(const IStaticBattery* battery) const = 0;
    virtual void onCollision(const IStaticBattery* battery1, const IStaticBattery* battery2) ;
    virtual void onBatteryActivation(const IStaticBattery* battery);
    virtual void onBatteryDeath(const IStaticBattery* battery);


SStats PlayerStats;


//    {
//        return Progression;
//    }

    irr::u32 getElapsedTime() const ;
//    void shakeCamera();


    void addSimpleExplosion(const TVector3df& position );

    irr::scene::IAnimatedMeshSceneNode* addAnimatedNode();

//    void onResume();
    void onHold();

	void Draw();




    virtual std::wstring generateDebugData() const;

//    bool isPlaying() const
//    {
//        return ( (CurrentPhase == Phase::Playing)
//                || (CurrentPhase == Phase::Boss)
//                || (CurrentPhase == Phase::FadeOut)
//                );
//    }

    //bool isPlaying() const

//    static TVector3df getPlayerForwardVector() { return TVector3df(0,1,0) };



    CAlliedFleet* getAlliedFleet() { return _alliedFleet; };
    CEnemyFleet* getEnemyFleet() { return _enemyFleet; };

    irr::scene::IAnimatedMesh*  getMesh(const char* filename);
    //CBatteryModel* createBatteryModel(const char* filename,const int& life,const int& bonus,const float& range);
   // CModel* createBatteryModel(const char* filename,const int& life,const int& bonus,const float& range);

    //! TODO passer en virtual ptet ?
//    CStaticBattery* getNextTarget();

// TODO pvr le modifier depuis LUA



//    bool BasicUpdatePositionFunction(const TTimer::TimeType& elapsedTime);


    virtual float getProgression() const = 0;
protected:
//    float Progression;

    irr::core::vector3df _playerPreviousPos;

    void setupPlayerForNewGame();
//    virtual void update3rdPersonCamera();
    virtual void renderDebugData() {};


    //! update player Contexte
    virtual void updatePlayer(const TPlayerId& player,const TTimeUnit& elapsedTime) ;




    //! todo a le mettre dans le CPlayer
    int _blinksCounter;     //!< BlinksCounter

    //!
//    void renderHUD(  irr::video::ITexture* );

//    void DrawLeftHUD(const irr::core::position2di& upperLeft);
//    void DrawRightHUD(const irr::core::position2di& upperLeft);

    void drawExplosions();

private:
    bool ShowDebugData;

};

#endif
